'###_CREDITS_###################################################################
'imgloader 1.1
'2008-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"
#include once "3th/pload2.bas"

'###_SHARED_VALUES_#############################################################

'###_FUNCTIONES_################################################################
'-------------------------------------------------------------------------------
declare sub loadimg(image_name() as any ptr, image_path as string, size_x as integer=0, size_y as integer=0, max_frames as ushort=1)
sub         loadimg(image_name() as any ptr, image_path as string, size_x as integer=0, size_y as integer=0, max_frames as ushort=1)
    
    dim as ushort for_next
    dim as any ptr image_buffer
    
    if size_x = 0 and size_y = 0 then
        image_name(1) = pload2(image_path)
    else
        image_buffer = pload2(image_path)
        for for_next = 1 to max_frames
            image_name(for_next) = imagecreate(size_x,size_y)
            put image_name(for_next),(size_x+(-size_x*for_next),0),image_buffer,pset
        next
        imagedestroy image_buffer
    endif
    
end sub

'-------------------------------------------------------------------------------
declare sub loadtile(image_name() as any ptr, image_path as string, rows_x as ushort, tile_size_x as short, rows_y as ushort=0, tile_size_y as short=0)
sub         loadtile(image_name() as any ptr, image_path as string, rows_x as ushort, tile_size_x as short, rows_y as ushort=0, tile_size_y as short=0)
    
    dim as short for_next, max_frames, pos_x, pos_y, timer_1, timer_2
    dim as any ptr image_buffer
    
    'set_max_frames
    if tile_size_y = 0 then
        max_frames = rows_x * rows_x
    else
        max_frames = rows_x * rows_y
    endif
    
    'put_images
    image_buffer = pload2(image_path)
    if tile_size_y = 0 then
        for for_next = 1 to max_frames
            image_name(for_next) = imagecreate(tile_size_x,tile_size_x)
            timer_1 = timer_1 + 1
            if timer_1 > rows_x then
                timer_1 = 1
                timer_2 = timer_2 + 1
                pos_y = -tile_size_x * timer_2
            endif
            pos_x = tile_size_x - tile_size_x * timer_1
            put image_name(for_next),(pos_x,pos_y),image_buffer,pset
        next
    else
        for for_next = 1 to max_frames
            image_name(for_next) = imagecreate(tile_size_x,tile_size_y)
            timer_1 = timer_1 + 1
            if timer_1 > rows_x then
                timer_1 = 1
                timer_2 = timer_2 + 1
                pos_y = -tile_size_y * timer_2
            endif
            pos_x = tile_size_x - tile_size_x * timer_1
            put image_name(for_next),(pos_x,pos_y),image_buffer,pset
        next
    endif
    imagedestroy image_buffer
    
end sub

'-------------------------------------------------------------------------------
declare sub drawimg(image_name as any ptr, pos_x as integer=0, pos_y as integer=0, special_fx as ubyte=1, special_fx_value as ubyte=255)
sub         drawimg(image_name as any ptr, pos_x as integer=0, pos_y as integer=0, special_fx as ubyte=1, special_fx_value as ubyte=255)
    
    select case as const special_fx
    case 0
        put (pos_x,pos_y),image_name,pset
    case 1
        put (pos_x,pos_y),image_name,trans
    case 2
        put (pos_x,pos_y),image_name,alpha,special_fx_value
    case 3
        put (pos_x,pos_y),image_name,alpha
    case 4
        put (pos_x,pos_y),image_name,add,special_fx_value
    case 5
        put (pos_x,pos_y),image_name,and
    case 6
        put (pos_x,pos_y),image_name,or
    case 7
        put (pos_x,pos_y),image_name,xor
    case 8
        put (pos_x,pos_y),image_name,preset
    'case 9
        'Put (pos_x,pos_y),image_name,custom
    case 11'flip horizontal
        dim as uinteger fn, img_width, img_height
        if imageinfo(image_name,img_width,img_height) <> 0 then exit sub
        for fn as uinteger = 0 To img_width - 1
            put ((pos_x + fn),pos_y), image_name, (img_width - 1 - fn,0) - step(0, img_height-1), trans
        next
    case 12'flip vertical
        dim as uinteger fn, img_width, img_height
        if imageinfo(image_name,img_width,img_height) <> 0 then exit sub
        for fn as uinteger = 0 To img_height - 1
            put (pos_x,(pos_y + fn)), image_name, (0, img_height - 1 - fn) - step(img_width-1, 0), trans
        next
    end select
    
end sub

'###_EXAMPLE_###################################################################
/'
screenres 640,480,32

dim shared as any ptr img_tile(9), img_tile_2(1)

loadtile(img_tile(9),"tiles.png",32,3)
loadimg(img_tile_2(1),"tiles.png",96,96)

drawimg(img_tile(1),0       ,0,2)
drawimg(img_tile(2),32+1    ,0,0)
drawimg(img_tile(3),64+2    ,0)
drawimg(img_tile(4),0       ,32+1)
drawimg(img_tile(5),32+1    ,32+1)
drawimg(img_tile(6),64+2    ,32+1)
drawimg(img_tile(7),0       ,64+2)
drawimg(img_tile(8),32+1    ,64+2)
drawimg(img_tile(9),64+2    ,64+2)

drawimg(img_tile_2(1),0     ,128)

sleep
'/
