'###_CREDITS_###################################################################
'SpeedGUI 1.0
'2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"
#include once "n3trunn3r/imgloader.bas"
#include once "n3trunn3r/print2.bas"
#include once "n3trunn3r/mouse.bas"

'###_SHARED_VALUES_#############################################################
'misc
const      as byte      true=1, false=0
dim shared as byte      sgui_size = 13'check box, radio button height and wide
dim shared as byte      sgui_size_b = 21'combo box, button and spin button height

'images
dim shared as any ptr   sgui_img_check(6)
dim shared as any ptr   sgui_img_button(15)
dim shared as any ptr   sgui_img_combo(9)

'configuration
dim shared as ubyte     cfg_r, cfg_g, cfg_b'bg color
dim shared as ubyte     sgui_grp_max = 96'max number of each object
dim shared as ubyte     sgui_itm_max = 128'max items in an object (combo box)
dim shared as short     sgui_co_grp_open'current opened combo box

'values
dim shared as short     sgui_ch(sgui_grp_max)'selected check box, yes/no
dim shared as short     sgui_ra_grp(sgui_grp_max)'current selected radio button of a radio group
dim shared as short     sgui_co_itm(sgui_grp_max)'max items in a combo box
dim shared as short     sgui_co_itm_sel(sgui_grp_max)'current used item
dim shared as string    sgui_co_grp(sgui_grp_max,sgui_itm_max)'item content
'dim shared as short     sgui_sp_itm(sgui_grp_max)'max spin boxes
'                        sgui_sp_itm(1) = 10

'###_FUNCTIONES_################################################################
declare sub sgui_init()
declare sub sgui_bg(pos_x as short=0, pos_y as short=0, size_x as ushort=1024, size_y as ushort=768)
declare sub sgui_action(sgui_id as short)'put into another file
declare sub sgui_check  (sgui_x as short, sgui_y as short, sgui_id as short)
declare sub sgui_radio  (sgui_x as short, sgui_y as short, sgui_id as short, sgui_id_group as short)
declare sub sgui_button (sgui_x as short, sgui_y as short, sgui_id as short, sgui_button_size as short=80, sgui_label as string)
declare sub sgui_combo  (sgui_x as short, sgui_y as short, sgui_id as short, sgui_id_group as short, sgui_button_size as short=80)
declare sub sgui_spin   (sgui_x as short, sgui_y as short, byref sgui_id as short, sgui_button_size as short=60)
declare sub sgui_msg()
declare sub sgui_scroll()

'-------------------------------------------------------------------------------
sub sgui_init()
    
    chdir("Themes")
    
        'read theme.ini
        dim as string file_theme_path = "theme.ini"
        dim as string theme_dir
        dim as byte file_theme=freefile
        'check
        if open(file_theme_path for input as #file_theme) <> 0 then
            open file_theme_path for output as #file_theme
                write #file_theme, "default"
            close
        endif
        'read
        open file_theme_path for input as #file_theme
            input #file_theme, theme_dir
        close
        
        'fonts
        loadimg(img_font(),"sgui_font.png",8,9,254)
        
    chdir(theme_dir)
        
        'read theme.ini
        dim as string file_cfg_path = "cfg.ini"
        dim as byte file_cfg=freefile
        'check
        if open(file_cfg_path for input as #file_cfg) <> 0 then
            open file_cfg_path for output as #file_cfg
                write #file_cfg, 128,128,128
            close
        endif
        'read
        open file_cfg_path for input as #file_cfg
            input #file_cfg, cfg_r, cfg_g, cfg_b 'bg color
        close
        
        'gui images
        loadimg(sgui_img_check(),"check.png",   sgui_size,  sgui_size,  6)
        loadimg(sgui_img_button(),"button.png", 2,          sgui_size_b,15)
        loadimg(sgui_img_combo(),"combo.png",   sgui_size_b,sgui_size_b,9)
        
    chdir("..")
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub sgui_bg(pos_x as short=0, pos_y as short=0, size_x as ushort=1024, size_y as ushort=768)
    
    color rgb(cfg_r,cfg_g,cfg_b)
    line (pos_x, pos_y) - (pos_x + size_x - 1, pos_y + size_y - 1),,bf
    
end sub

'-------------------------------------------------------------------------------
sub sgui_check(sgui_x as short, sgui_y as short, sgui_id as short)
    
    'box
    put (sgui_x,sgui_y),sgui_img_check(1),trans
    
    'mouse
    if mouse_x > sgui_x and mouse_x <= (sgui_x + sgui_size) and _
       mouse_y > sgui_y and mouse_y <= (sgui_y + sgui_size) then
        put (sgui_x,sgui_y),sgui_img_check(2),trans
        if mouse_hit then
            if sgui_ch(sgui_id) = false then
                sgui_ch(sgui_id) = true
            elseif sgui_ch(sgui_id) = true then
                sgui_ch(sgui_id) = false
            endif
            sgui_action(sgui_id)
        endif
    endif
    
    'check mark
    if sgui_ch(sgui_id) = true then
        put (sgui_x,sgui_y),sgui_img_check(3),trans
    endif
    
end sub

'-------------------------------------------------------------------------------
sub sgui_radio(sgui_x as short, sgui_y as short, sgui_id as short, sgui_id_group as short)
    
    'radio
    put (sgui_x,sgui_y),sgui_img_check(4),trans
    
    'mouse
    if mouse_x > sgui_x and mouse_x <= (sgui_x + sgui_size) and _
       mouse_y > sgui_y and mouse_y <= (sgui_y + sgui_size) then
        put (sgui_x,sgui_y),sgui_img_check(5),trans
        if mouse_hit then
            sgui_ra_grp(sgui_id_group) = sgui_id
            sgui_action(sgui_id)
        endif
    endif
    
    'check mark
    if sgui_id = sgui_ra_grp(sgui_id_group) then
        put (sgui_x,sgui_y),sgui_img_check(6),trans
    endif
    
end sub

'-------------------------------------------------------------------------------
sub sgui_button(sgui_x as short, sgui_y as short, sgui_id as short, sgui_button_size as short=80, sgui_label as string)
    
    dim as short fn
    
    'button
    put (sgui_x,sgui_y),sgui_img_button(1),trans
    put (sgui_x+(sgui_button_size-2),sgui_y),sgui_img_button(2),trans
    for fn = 2 to (sgui_button_size-3)
        put (sgui_x+fn,sgui_y),sgui_img_button(3),trans
    next
    print2(sgui_label,(sgui_x+(sgui_button_size/2)-2),sgui_y+6,1)
        
    'mouse
    if mouse_x > sgui_x and mouse_x <= (sgui_x + sgui_button_size) and _
       mouse_y > sgui_y and mouse_y <= (sgui_y + 21) then
        'hover
        put (sgui_x,sgui_y),sgui_img_button(4),trans
        put (sgui_x+(sgui_button_size-2),sgui_y),sgui_img_button(5),trans
        for fn = 2 to (sgui_button_size-3)
            put (sgui_x+fn,sgui_y),sgui_img_button(6),trans
        next
        print2(sgui_label,(sgui_x+(sgui_button_size/2)-2),sgui_y+6,1)
        if mouse_down then
            'button down
            put (sgui_x,sgui_y),sgui_img_button(7),trans
            put (sgui_x+(sgui_button_size-2),sgui_y),sgui_img_button(8),trans
            for fn = 2 to (sgui_button_size-3)
                put (sgui_x+fn,sgui_y),sgui_img_button(9),trans
            next
            print2(sgui_label,(sgui_x+(sgui_button_size/2)-2+1),sgui_y+6+1,1)
            sgui_action(sgui_id)
        endif
    endif
    
end sub

'-------------------------------------------------------------------------------
sub sgui_combo(sgui_x as short, sgui_y as short, sgui_id as short, sgui_id_group as short, sgui_button_size as short=80)
    
    dim as short fn
    
    'box frame
    put (sgui_x,sgui_y),sgui_img_button(10),trans
    put (sgui_x+(sgui_button_size-2),sgui_y),sgui_img_button(11),trans
    for fn = 2 to (sgui_button_size-3)
        put (sgui_x+fn,sgui_y),sgui_img_button(12),trans
    next
    'current object
    print2(sgui_co_grp(sgui_id_group,sgui_co_itm_sel(sgui_id_group)),(sgui_x+((sgui_button_size-sgui_size_b)/2)-2),sgui_y+6,1)
    'open button
    put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(1),trans
    
    'mouse open button
    if mouse_x > (sgui_x + (sgui_button_size - sgui_size_b)) and mouse_x <= (sgui_x + sgui_button_size) and _
       mouse_y > sgui_y and mouse_y <= (sgui_y + sgui_size_b) then
        'button
        if mouse_down then'pushed
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(3),trans
        else'hover
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(2),trans
        endif
        'open box
        if mouse_hit then
            if sgui_co_grp_open = 0 then
                sgui_co_grp_open = sgui_id
            elseif sgui_co_grp_open <> sgui_id then
                'nothing
            elseif sgui_co_grp_open = sgui_id then
                'close box
                sgui_co_grp_open = 0
            endif
        endif
    endif
    
    'opened box
    if sgui_co_grp_open = sgui_id then
        'button down
        dim as short fn_b
        for fn_b = 1 to sgui_co_itm(sgui_id_group)
            'box frame open
            put (sgui_x,                        sgui_y+(sgui_size_b*fn_b)),     sgui_img_button(10),trans
            put (sgui_x+(sgui_button_size-2),   sgui_y+(sgui_size_b*fn_b)),     sgui_img_button(11),trans
            for fn = 2 to (sgui_button_size-3)
                put (sgui_x+fn,                 sgui_y+(sgui_size_b*fn_b)),     sgui_img_button(12),trans
            next
            'select object
            if mouse_x > sgui_x and mouse_x <= (sgui_x + sgui_button_size) and _
            mouse_y > (sgui_y + (sgui_size_b * fn_b)) and mouse_y <= ((sgui_y + (sgui_size_b * fn_b)) + sgui_size_b) then
                'box frame
                put (sgui_x,(sgui_y + (sgui_size_b * fn_b))),sgui_img_button(13),trans
                put (sgui_x+(sgui_button_size-2),(sgui_y + (sgui_size_b * fn_b))),sgui_img_button(14),trans
                for fn = 2 to (sgui_button_size-3)
                    put (sgui_x+fn,(sgui_y + (sgui_size_b * fn_b))),sgui_img_button(15),trans
                next
                if mouse_hit then
                    'change item
                    sgui_co_itm_sel(sgui_id_group) = fn_b
                    'close box
                    sgui_co_grp_open = 0
                    'event
                    sgui_action(sgui_id)
                endif
            endif
            'objects
            print2(sgui_co_grp(sgui_id_group,fn_b),(sgui_x+((sgui_button_size)/2)-2),sgui_y+6+(sgui_size_b*fn_b),1)
        next
    endif
    
end sub

'-------------------------------------------------------------------------------
sub sgui_spin(sgui_x as short, sgui_y as short, byref sgui_id as short, sgui_button_size as short=60)
    
    dim as short fn
    
    'box frame
    put (sgui_x,sgui_y),sgui_img_button(10),trans
    put (sgui_x+(sgui_button_size-2),sgui_y),sgui_img_button(11),trans
    for fn = 2 to (sgui_button_size-3)
        put (sgui_x+fn,sgui_y),sgui_img_button(12),trans
    next
    
    'change button
    put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(4),trans
    put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(7),trans
    
    'mouse up button
    if mouse_x > (sgui_x + (sgui_button_size - sgui_size_b)) and mouse_x <= (sgui_x + sgui_button_size) and _
       mouse_y > sgui_y and mouse_y <= (sgui_y + (sgui_size_b / 2)) then
        'button
        if mouse_down then'pushed
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(9),trans
        else'hover
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(8),trans
        endif
        if mouse_down then'hit
            sgui_id = sgui_id + 1
            'sgui_sp_itm(sgui_id) = sgui_sp_itm(sgui_id) + 1
            mouse_speedup()
        endif
    'mouse down button
    elseif mouse_x > (sgui_x + (sgui_button_size - sgui_size_b)) and mouse_x <= (sgui_x + sgui_button_size) and _
       mouse_y > (sgui_y + (sgui_size_b / 2)) and mouse_y <= (sgui_y + sgui_size_b) then
        'button
        if mouse_down then'pushed
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(6),trans
        else'hover
            put (sgui_x+sgui_button_size-sgui_size_b,sgui_y),sgui_img_combo(5),trans
        endif
        if mouse_down then'hit
            sgui_id = sgui_id - 1
            'sgui_sp_itm(sgui_id) = sgui_sp_itm(sgui_id) - 1
            mouse_speedup()
        endif
    endif
    
    'current object
    print2(str(sgui_id),(sgui_x+((sgui_button_size-sgui_size_b)/2)-2),sgui_y+6,1)
    'print2(str(sgui_sp_itm(sgui_id)),(sgui_x+((sgui_button_size-sgui_size_b)/2)-2),sgui_y+6,1)
    
end sub

'-------------------------------------------------------------------------------
sub sgui_msg()
    
    
    
end sub

'-------------------------------------------------------------------------------
sub sgui_scroll()
    
    
    
end sub
